package at.compax.tools.sql.model;

import java.util.List;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;

import lombok.Builder;
import lombok.Getter;
import lombok.ToString;

@Getter
@Builder
@ToString
@JsonInclude(JsonInclude.Include.NON_NULL)
public class QueryResult {
	@Getter
	@Builder
	@ToString
	@JsonInclude(JsonInclude.Include.NON_NULL)
	public static class Row {
		@Getter
		@Builder
		@ToString
		@JsonInclude(JsonInclude.Include.NON_NULL)
		public static class Column {
			@JsonProperty("name")
			private String name;
			@JsonProperty("value")
			private Object value;
		}

		@JsonProperty("columns")
		private List<Column> columns;
	}

	@JsonProperty("rows")
	private List<Row> rows;
	@JsonProperty("userErrors")
	private List<UserError> userErrors;
	@JsonProperty("exception")
	private String exception;
	@JsonProperty("exceptionMessage")
	private String exceptionMessage;
}
